Create agentic purchase
curl --request POST \
--url https://api.natural.com/agentic-payments/purchases \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"mandateId": "amd_01a0e6466ba3713bba0f0d9d36803b92",
"amount": 2450,
"currency": "USD",
"merchant": {
"name": "Blue Bottle Coffee",
"url": "https://bluebottlecoffee.com",
"countryCode": "US"
},
"ttlSeconds": 600
}
}
}
'import requests
url = "https://api.natural.com/agentic-payments/purchases"
payload = { "data": { "attributes": {
"mandateId": "amd_01a0e6466ba3713bba0f0d9d36803b92",
"amount": 2450,
"currency": "USD",
"merchant": {
"name": "Blue Bottle Coffee",
"url": "https://bluebottlecoffee.com",
"countryCode": "US"
},
"ttlSeconds": 600
} } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
data: {
attributes: {
mandateId: 'amd_01a0e6466ba3713bba0f0d9d36803b92',
amount: 2450,
currency: 'USD',
merchant: {
name: 'Blue Bottle Coffee',
url: 'https://bluebottlecoffee.com',
countryCode: 'US'
},
ttlSeconds: 600
}
}
})
};
fetch('https://api.natural.com/agentic-payments/purchases', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/agentic-payments/purchases",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'mandateId' => 'amd_01a0e6466ba3713bba0f0d9d36803b92',
'amount' => 2450,
'currency' => 'USD',
'merchant' => [
'name' => 'Blue Bottle Coffee',
'url' => 'https://bluebottlecoffee.com',
'countryCode' => 'US'
],
'ttlSeconds' => 600
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/agentic-payments/purchases"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"mandateId\": \"amd_01a0e6466ba3713bba0f0d9d36803b92\",\n \"amount\": 2450,\n \"currency\": \"USD\",\n \"merchant\": {\n \"name\": \"Blue Bottle Coffee\",\n \"url\": \"https://bluebottlecoffee.com\",\n \"countryCode\": \"US\"\n },\n \"ttlSeconds\": 600\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/agentic-payments/purchases")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"mandateId\": \"amd_01a0e6466ba3713bba0f0d9d36803b92\",\n \"amount\": 2450,\n \"currency\": \"USD\",\n \"merchant\": {\n \"name\": \"Blue Bottle Coffee\",\n \"url\": \"https://bluebottlecoffee.com\",\n \"countryCode\": \"US\"\n },\n \"ttlSeconds\": 600\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/agentic-payments/purchases")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"mandateId\": \"amd_01a0e6466ba3713bba0f0d9d36803b92\",\n \"amount\": 2450,\n \"currency\": \"USD\",\n \"merchant\": {\n \"name\": \"Blue Bottle Coffee\",\n \"url\": \"https://bluebottlecoffee.com\",\n \"countryCode\": \"US\"\n },\n \"ttlSeconds\": 600\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "apu_01a0e6466ba3713bba0f0d9d36803b93",
"mandateId": "amd_01a0e6466ba3713bba0f0d9d36803b92",
"provider": "basis_theory",
"confirmationStatus": "not_requested",
"amount": 2450,
"currency": "USD",
"merchant": {
"name": "Blue Bottle Coffee",
"url": "https://bluebottlecoffee.com",
"countryCode": "US"
},
"delivery": "card_token",
"status": "prepared",
"expiresAt": null,
"errorCode": null
}
}Agent tokens
Create agentic purchase
As an agent, reserve part of a mandate’s budget for one purchase. The amount must not exceed the mandate’s perPurchaseLimit or available amount, or the call fails with 409.
POST
/
agentic-payments
/
purchases
Create agentic purchase
curl --request POST \
--url https://api.natural.com/agentic-payments/purchases \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"mandateId": "amd_01a0e6466ba3713bba0f0d9d36803b92",
"amount": 2450,
"currency": "USD",
"merchant": {
"name": "Blue Bottle Coffee",
"url": "https://bluebottlecoffee.com",
"countryCode": "US"
},
"ttlSeconds": 600
}
}
}
'import requests
url = "https://api.natural.com/agentic-payments/purchases"
payload = { "data": { "attributes": {
"mandateId": "amd_01a0e6466ba3713bba0f0d9d36803b92",
"amount": 2450,
"currency": "USD",
"merchant": {
"name": "Blue Bottle Coffee",
"url": "https://bluebottlecoffee.com",
"countryCode": "US"
},
"ttlSeconds": 600
} } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
data: {
attributes: {
mandateId: 'amd_01a0e6466ba3713bba0f0d9d36803b92',
amount: 2450,
currency: 'USD',
merchant: {
name: 'Blue Bottle Coffee',
url: 'https://bluebottlecoffee.com',
countryCode: 'US'
},
ttlSeconds: 600
}
}
})
};
fetch('https://api.natural.com/agentic-payments/purchases', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/agentic-payments/purchases",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'mandateId' => 'amd_01a0e6466ba3713bba0f0d9d36803b92',
'amount' => 2450,
'currency' => 'USD',
'merchant' => [
'name' => 'Blue Bottle Coffee',
'url' => 'https://bluebottlecoffee.com',
'countryCode' => 'US'
],
'ttlSeconds' => 600
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/agentic-payments/purchases"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"mandateId\": \"amd_01a0e6466ba3713bba0f0d9d36803b92\",\n \"amount\": 2450,\n \"currency\": \"USD\",\n \"merchant\": {\n \"name\": \"Blue Bottle Coffee\",\n \"url\": \"https://bluebottlecoffee.com\",\n \"countryCode\": \"US\"\n },\n \"ttlSeconds\": 600\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/agentic-payments/purchases")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"mandateId\": \"amd_01a0e6466ba3713bba0f0d9d36803b92\",\n \"amount\": 2450,\n \"currency\": \"USD\",\n \"merchant\": {\n \"name\": \"Blue Bottle Coffee\",\n \"url\": \"https://bluebottlecoffee.com\",\n \"countryCode\": \"US\"\n },\n \"ttlSeconds\": 600\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/agentic-payments/purchases")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"mandateId\": \"amd_01a0e6466ba3713bba0f0d9d36803b92\",\n \"amount\": 2450,\n \"currency\": \"USD\",\n \"merchant\": {\n \"name\": \"Blue Bottle Coffee\",\n \"url\": \"https://bluebottlecoffee.com\",\n \"countryCode\": \"US\"\n },\n \"ttlSeconds\": 600\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "apu_01a0e6466ba3713bba0f0d9d36803b93",
"mandateId": "amd_01a0e6466ba3713bba0f0d9d36803b92",
"provider": "basis_theory",
"confirmationStatus": "not_requested",
"amount": 2450,
"currency": "USD",
"merchant": {
"name": "Blue Bottle Coffee",
"url": "https://bluebottlecoffee.com",
"countryCode": "US"
},
"delivery": "card_token",
"status": "prepared",
"expiresAt": null,
"errorCode": null
}
}Authorizations
Headers
Was this page helpful?